
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega16
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _s=R5
	.DEF _m=R4
	.DEF _n=R7
	.DEF _sm=R6
	.DEF _boot=R9
	.DEF __lcd_x=R8
	.DEF __lcd_y=R11
	.DEF __lcd_maxx=R10

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _ext_int2_isr
	JMP  0x00
	JMP  0x00

_0x0:
	.DB  0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0x0,0x2D,0x6F,0x76,0x65,0x72,0x66
	.DB  0x6C,0x6F,0x77,0x2D,0x0,0x44,0x69,0x67
	.DB  0x69,0x74,0x61,0x6C,0x20,0x64,0x6F,0x73
	.DB  0x69,0x6D,0x65,0x74,0x65,0x72,0x20,0x76
	.DB  0x32,0x0,0x50,0x6C,0x65,0x61,0x73,0x65
	.DB  0x2C,0x20,0x77,0x61,0x69,0x74,0x20,0x2E
	.DB  0x2E,0x2E,0x0,0x28,0x63,0x29,0x20,0x4A
	.DB  0x69,0x72,0x69,0x20,0x43,0x65,0x63,0x68
	.DB  0x20,0x38,0x2F,0x32,0x30,0x31,0x33,0x0
	.DB  0x2D,0x6F,0x76,0x65,0x72,0x2D,0x0,0x4E
	.DB  0x4F,0x52,0x4D,0x2E,0x0,0x47,0x4F,0x4F
	.DB  0x44,0x20,0x0,0x78,0x0,0x75,0x52,0x2F
	.DB  0x68,0x0,0x7C,0x0,0x63,0x70,0x6D,0x0
	.DB  0x55,0x50,0x44,0x41,0x54,0x45,0x3A,0x0
	.DB  0x73,0x0,0x63,0x70,0x68,0x0,0x63,0x74
	.DB  0x74,0x0
_0x2000003:
	.DB  0x80,0xC0
_0x2020060:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x0A
	.DW  _0x7
	.DW  _0x0*2

	.DW  0x09
	.DW  _0x7+10
	.DW  _0x0*2+1

	.DW  0x08
	.DW  _0x7+19
	.DW  _0x0*2+2

	.DW  0x07
	.DW  _0x7+27
	.DW  _0x0*2+3

	.DW  0x06
	.DW  _0x7+34
	.DW  _0x0*2+4

	.DW  0x05
	.DW  _0x7+40
	.DW  _0x0*2+5

	.DW  0x04
	.DW  _0x7+45
	.DW  _0x0*2+6

	.DW  0x03
	.DW  _0x7+49
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x7+52
	.DW  _0x0*2+8

	.DW  0x0B
	.DW  _0x7+54
	.DW  _0x0*2+10

	.DW  0x15
	.DW  _0x22
	.DW  _0x0*2+21

	.DW  0x11
	.DW  _0x22+21
	.DW  _0x0*2+42

	.DW  0x15
	.DW  _0x22+38
	.DW  _0x0*2+59

	.DW  0x02
	.DW  _0x22+59
	.DW  _0x0*2+8

	.DW  0x05
	.DW  _0x22+61
	.DW  _0x0*2+5

	.DW  0x04
	.DW  _0x22+66
	.DW  _0x0*2+6

	.DW  0x03
	.DW  _0x22+70
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x22+73
	.DW  _0x0*2+8

	.DW  0x07
	.DW  _0x22+75
	.DW  _0x0*2+80

	.DW  0x06
	.DW  _0x22+82
	.DW  _0x0*2+87

	.DW  0x06
	.DW  _0x22+88
	.DW  _0x0*2+93

	.DW  0x02
	.DW  _0x22+94
	.DW  _0x0*2+8

	.DW  0x03
	.DW  _0x22+96
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x22+99
	.DW  _0x0*2+99

	.DW  0x05
	.DW  _0x22+101
	.DW  _0x0*2+5

	.DW  0x04
	.DW  _0x22+106
	.DW  _0x0*2+6

	.DW  0x03
	.DW  _0x22+110
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x22+113
	.DW  _0x0*2+8

	.DW  0x07
	.DW  _0x22+115
	.DW  _0x0*2+80

	.DW  0x05
	.DW  _0x22+122
	.DW  _0x0*2+5

	.DW  0x04
	.DW  _0x22+127
	.DW  _0x0*2+6

	.DW  0x03
	.DW  _0x22+131
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x22+134
	.DW  _0x0*2+8

	.DW  0x07
	.DW  _0x22+136
	.DW  _0x0*2+80

	.DW  0x05
	.DW  _0x22+143
	.DW  _0x0*2+101

	.DW  0x02
	.DW  _0x22+148
	.DW  _0x0*2+106

	.DW  0x04
	.DW  _0x22+150
	.DW  _0x0*2+108

	.DW  0x08
	.DW  _0x22+154
	.DW  _0x0*2+112

	.DW  0x02
	.DW  _0x22+162
	.DW  _0x0*2+120

	.DW  0x02
	.DW  _0x22+164
	.DW  _0x0*2+106

	.DW  0x04
	.DW  _0x22+166
	.DW  _0x0*2+122

	.DW  0x02
	.DW  _0x22+170
	.DW  _0x0*2+106

	.DW  0x02
	.DW  _0x22+172
	.DW  _0x0*2+106

	.DW  0x04
	.DW  _0x22+174
	.DW  _0x0*2+126

	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x2020060*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.0 Professional
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : Digital dosimeter
;Version : 2.0
;Date    : 2.8.2013
;Author  : Ji ech
;Company : Silicon Source
;Comments:
;
;
;
;Chip type               : ATmega16
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;
;// Alphanumeric LCD Module functions
;#include <alcd.h>
;
;#include <stdlib.h>
;
;
;
;
;
;unsigned long  int cpm;
;unsigned long int cph;
;char s;
;char m;
;char n;
;unsigned long int ctt;
;unsigned long int urh;
;char sm;
;unsigned char boot;
;
;char cpmc[15];
;char cphc[15];
;char cttc[27];
;char sc[6];
;char urhc[15];
;char nc[9];
;
;// External Interrupt 1 service routine
;interrupt [EXT_INT2] void ext_int2_isr(void)
; 0000 0039 {

	.CSEG
_ext_int2_isr:
	CALL SUBOPT_0x0
; 0000 003A // Place your code here
; 0000 003B 
; 0000 003C if(boot==1){
	BREQ PC+3
	JMP _0x3
; 0000 003D 
; 0000 003E cpm++;
	LDI  R26,LOW(_cpm)
	LDI  R27,HIGH(_cpm)
	CALL SUBOPT_0x1
; 0000 003F cph++;
	LDI  R26,LOW(_cph)
	LDI  R27,HIGH(_cph)
	CALL SUBOPT_0x1
; 0000 0040 ctt++;
	LDI  R26,LOW(_ctt)
	LDI  R27,HIGH(_ctt)
	CALL SUBOPT_0x1
; 0000 0041 if(s==60){
	LDI  R30,LOW(60)
	CP   R30,R5
	BRNE _0x4
; 0000 0042 cpm=0;
	CALL SUBOPT_0x2
; 0000 0043 }
; 0000 0044 
; 0000 0045 if(m==60){
_0x4:
	LDI  R30,LOW(60)
	CP   R30,R4
	BRNE _0x5
; 0000 0046 cph=0;
	CALL SUBOPT_0x3
; 0000 0047 }
; 0000 0048 ltoa(ctt,cttc);
_0x5:
	CALL SUBOPT_0x4
	CALL __PUTPARD1
	CALL SUBOPT_0x5
	CALL _ltoa
; 0000 0049 
; 0000 004A 
; 0000 004B if(ctt<10){
	CALL SUBOPT_0x6
	BRSH _0x6
; 0000 004C lcd_gotoxy(6,3);
	CALL SUBOPT_0x7
; 0000 004D lcd_puts("000000000");
	__POINTW1MN _0x7,0
	CALL SUBOPT_0x8
; 0000 004E lcd_gotoxy(15,3);
	LDI  R30,LOW(15)
	CALL SUBOPT_0x9
; 0000 004F lcd_puts(cttc);
	CALL _lcd_puts
; 0000 0050 }
; 0000 0051 
; 0000 0052 if(ctt>9 && ctt<100){
_0x6:
	CALL SUBOPT_0x6
	BRLO _0x9
	CALL SUBOPT_0xA
	BRLO _0xA
_0x9:
	RJMP _0x8
_0xA:
; 0000 0053 lcd_gotoxy(6,3);
	CALL SUBOPT_0x7
; 0000 0054 lcd_puts("00000000");
	__POINTW1MN _0x7,10
	CALL SUBOPT_0x8
; 0000 0055 lcd_gotoxy(14,3);
	LDI  R30,LOW(14)
	CALL SUBOPT_0x9
; 0000 0056 lcd_puts(cttc);
	CALL _lcd_puts
; 0000 0057 }
; 0000 0058 
; 0000 0059 if(ctt>99 && ctt<1000){
_0x8:
	CALL SUBOPT_0xA
	BRLO _0xC
	CALL SUBOPT_0xB
	BRLO _0xD
_0xC:
	RJMP _0xB
_0xD:
; 0000 005A lcd_gotoxy(6,3);
	CALL SUBOPT_0x7
; 0000 005B lcd_puts("0000000");
	__POINTW1MN _0x7,19
	CALL SUBOPT_0x8
; 0000 005C lcd_gotoxy(13,3);
	LDI  R30,LOW(13)
	CALL SUBOPT_0x9
; 0000 005D lcd_puts(cttc);
	CALL _lcd_puts
; 0000 005E }
; 0000 005F 
; 0000 0060 if(ctt>999 && ctt<10000){
_0xB:
	CALL SUBOPT_0xB
	BRLO _0xF
	CALL SUBOPT_0xC
	BRLO _0x10
_0xF:
	RJMP _0xE
_0x10:
; 0000 0061 lcd_gotoxy(6,3);
	CALL SUBOPT_0x7
; 0000 0062 lcd_puts("000000");
	__POINTW1MN _0x7,27
	CALL SUBOPT_0x8
; 0000 0063 lcd_gotoxy(12,3);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x9
; 0000 0064 lcd_puts(cttc);
	CALL _lcd_puts
; 0000 0065 }
; 0000 0066 
; 0000 0067 if(ctt>9999 && ctt<100000 ){
_0xE:
	CALL SUBOPT_0xC
	BRLO _0x12
	CALL SUBOPT_0xD
	BRLO _0x13
_0x12:
	RJMP _0x11
_0x13:
; 0000 0068 lcd_gotoxy(6,3);
	CALL SUBOPT_0x7
; 0000 0069 lcd_puts("00000");
	__POINTW1MN _0x7,34
	CALL SUBOPT_0x8
; 0000 006A lcd_gotoxy(11,3);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x9
; 0000 006B lcd_puts(cttc);
	CALL _lcd_puts
; 0000 006C }
; 0000 006D if(ctt>99999 && ctt<100000){
_0x11:
	CALL SUBOPT_0xD
	BRLO _0x15
	BRLO _0x16
_0x15:
	RJMP _0x14
_0x16:
; 0000 006E lcd_gotoxy(6,3);
	CALL SUBOPT_0x7
; 0000 006F lcd_puts("0000");
	__POINTW1MN _0x7,40
	CALL SUBOPT_0x8
; 0000 0070 lcd_gotoxy(10,3);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x9
; 0000 0071 lcd_puts(cttc);
	CALL _lcd_puts
; 0000 0072 }
; 0000 0073 if(ctt>999999 && ctt<1000000){
_0x14:
	CALL SUBOPT_0xE
	BRLO _0x18
	BRLO _0x19
_0x18:
	RJMP _0x17
_0x19:
; 0000 0074 lcd_gotoxy(6,3);
	CALL SUBOPT_0x7
; 0000 0075 lcd_puts("000");
	__POINTW1MN _0x7,45
	CALL SUBOPT_0x8
; 0000 0076 lcd_gotoxy(9,3);
	LDI  R30,LOW(9)
	CALL SUBOPT_0x9
; 0000 0077 lcd_puts(cttc);
	CALL _lcd_puts
; 0000 0078 
; 0000 0079 }
; 0000 007A 
; 0000 007B if(ctt>999999 && ctt<1000000){
_0x17:
	CALL SUBOPT_0xE
	BRLO _0x1B
	BRLO _0x1C
_0x1B:
	RJMP _0x1A
_0x1C:
; 0000 007C lcd_gotoxy(6,3);
	CALL SUBOPT_0x7
; 0000 007D lcd_puts("00");
	__POINTW1MN _0x7,49
	CALL SUBOPT_0x8
; 0000 007E lcd_gotoxy(8,3);
	LDI  R30,LOW(8)
	CALL SUBOPT_0x9
; 0000 007F lcd_puts(cttc);
	CALL _lcd_puts
; 0000 0080 }
; 0000 0081 
; 0000 0082 if(ctt>9999999 && ctt<10000000){
_0x1A:
	LDS  R26,_ctt
	LDS  R27,_ctt+1
	LDS  R24,_ctt+2
	LDS  R25,_ctt+3
	__CPD2N 0x989680
	BRLO _0x1E
	BRLO _0x1F
_0x1E:
	RJMP _0x1D
_0x1F:
; 0000 0083 lcd_gotoxy(6,3);
	CALL SUBOPT_0x7
; 0000 0084 lcd_puts("0");
	__POINTW1MN _0x7,52
	CALL SUBOPT_0x8
; 0000 0085 lcd_gotoxy(7,3);
	LDI  R30,LOW(7)
	CALL SUBOPT_0x9
; 0000 0086 lcd_puts(cttc);
	CALL _lcd_puts
; 0000 0087 }
; 0000 0088 
; 0000 0089 if(ctt>9999999999){
_0x1D:
	CALL SUBOPT_0x4
	CALL __CDF1U
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x501502F9
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x20
; 0000 008A lcd_gotoxy(6,3);
	CALL SUBOPT_0x7
; 0000 008B lcd_puts("-overflow-");
	__POINTW1MN _0x7,54
	CALL SUBOPT_0x8
; 0000 008C }
; 0000 008D 
; 0000 008E }
_0x20:
; 0000 008F }
_0x3:
	RJMP _0x5C

	.DSEG
_0x7:
	.BYTE 0x41
;// Timer2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0092 {

	.CSEG
_timer2_ovf_isr:
	CALL SUBOPT_0x0
; 0000 0093 // Place your code here
; 0000 0094 if(boot!=1){
	BRNE PC+3
	JMP _0x21
; 0000 0095 boot=1;
	LDI  R30,LOW(1)
	MOV  R9,R30
; 0000 0096 lcd_clear();
	CALL _lcd_clear
; 0000 0097 lcd_gotoxy(0,0);
	CALL SUBOPT_0xF
; 0000 0098 lcd_puts("Digital dosimeter v2");
	__POINTW1MN _0x22,0
	CALL SUBOPT_0x8
; 0000 0099 lcd_gotoxy(0,2);
	CALL SUBOPT_0x10
; 0000 009A lcd_puts("Please, wait ...");
	__POINTW1MN _0x22,21
	CALL SUBOPT_0x8
; 0000 009B lcd_gotoxy(0,3);
	CALL SUBOPT_0x11
; 0000 009C lcd_puts("(c) Jiri Cech 8/2013");
	__POINTW1MN _0x22,38
	CALL SUBOPT_0x8
; 0000 009D 
; 0000 009E 
; 0000 009F delay_ms(500);
	CALL SUBOPT_0x12
; 0000 00A0 lcd_gotoxy(0,1);
	LDI  R30,LOW(0)
	CALL SUBOPT_0x13
; 0000 00A1 lcd_putchar(0xFF);
; 0000 00A2 
; 0000 00A3 delay_ms(500);
; 0000 00A4 lcd_gotoxy(1,1);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x13
; 0000 00A5 lcd_putchar(0xFF);
; 0000 00A6 
; 0000 00A7 
; 0000 00A8 delay_ms(500);
; 0000 00A9 lcd_gotoxy(2,1);
	LDI  R30,LOW(2)
	CALL SUBOPT_0x13
; 0000 00AA lcd_putchar(0xFF);
; 0000 00AB 
; 0000 00AC delay_ms(500);
; 0000 00AD lcd_gotoxy(3,1);
	LDI  R30,LOW(3)
	CALL SUBOPT_0x13
; 0000 00AE lcd_putchar(0xFF);
; 0000 00AF 
; 0000 00B0 delay_ms(500);
; 0000 00B1 lcd_gotoxy(4,1);
	LDI  R30,LOW(4)
	CALL SUBOPT_0x13
; 0000 00B2 lcd_putchar(0xFF);
; 0000 00B3 
; 0000 00B4 delay_ms(500);
; 0000 00B5 lcd_gotoxy(5,1);
	LDI  R30,LOW(5)
	CALL SUBOPT_0x13
; 0000 00B6 lcd_putchar(0xFF);
; 0000 00B7 
; 0000 00B8 delay_ms(500);
; 0000 00B9 lcd_gotoxy(6,1);
	LDI  R30,LOW(6)
	CALL SUBOPT_0x13
; 0000 00BA lcd_putchar(0xFF);
; 0000 00BB 
; 0000 00BC delay_ms(500);
; 0000 00BD lcd_gotoxy(7,1);
	LDI  R30,LOW(7)
	CALL SUBOPT_0x13
; 0000 00BE lcd_putchar(0xFF);
; 0000 00BF 
; 0000 00C0 delay_ms(500);
; 0000 00C1 lcd_gotoxy(8,1);
	LDI  R30,LOW(8)
	CALL SUBOPT_0x13
; 0000 00C2 lcd_putchar(0xFF);
; 0000 00C3 
; 0000 00C4 delay_ms(500);
; 0000 00C5 lcd_gotoxy(9,1);
	LDI  R30,LOW(9)
	CALL SUBOPT_0x13
; 0000 00C6 lcd_putchar(0xFF);
; 0000 00C7 
; 0000 00C8 delay_ms(500);
; 0000 00C9 lcd_gotoxy(10,1);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x13
; 0000 00CA lcd_putchar(0xFF);
; 0000 00CB 
; 0000 00CC delay_ms(500);
; 0000 00CD lcd_gotoxy(11,1);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x13
; 0000 00CE lcd_putchar(0xFF);
; 0000 00CF 
; 0000 00D0 delay_ms(500);
; 0000 00D1 lcd_gotoxy(12,1);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x13
; 0000 00D2 lcd_putchar(0xFF);
; 0000 00D3 
; 0000 00D4 delay_ms(500);
; 0000 00D5 lcd_gotoxy(13,1);
	LDI  R30,LOW(13)
	CALL SUBOPT_0x13
; 0000 00D6 lcd_putchar(0xFF);
; 0000 00D7 
; 0000 00D8 delay_ms(500);
; 0000 00D9 lcd_gotoxy(14,1);
	LDI  R30,LOW(14)
	CALL SUBOPT_0x13
; 0000 00DA lcd_putchar(0xFF);
; 0000 00DB 
; 0000 00DC delay_ms(500);
; 0000 00DD lcd_gotoxy(15,1);
	LDI  R30,LOW(15)
	CALL SUBOPT_0x13
; 0000 00DE lcd_putchar(0xFF);
; 0000 00DF 
; 0000 00E0 delay_ms(500);
; 0000 00E1 lcd_gotoxy(16,1);
	LDI  R30,LOW(16)
	CALL SUBOPT_0x13
; 0000 00E2 lcd_putchar(0xFF);
; 0000 00E3 
; 0000 00E4 delay_ms(500);
; 0000 00E5 lcd_gotoxy(17,1);
	LDI  R30,LOW(17)
	CALL SUBOPT_0x13
; 0000 00E6 lcd_putchar(0xFF);
; 0000 00E7 
; 0000 00E8 delay_ms(500);
; 0000 00E9 lcd_gotoxy(18,1);
	LDI  R30,LOW(18)
	CALL SUBOPT_0x13
; 0000 00EA lcd_putchar(0xFF);
; 0000 00EB 
; 0000 00EC delay_ms(500);
; 0000 00ED lcd_gotoxy(19,1);
	LDI  R30,LOW(19)
	CALL SUBOPT_0x14
; 0000 00EE lcd_putchar(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 00EF 
; 0000 00F0 lcd_clear();
	CALL _lcd_clear
; 0000 00F1 
; 0000 00F2 
; 0000 00F3 }
; 0000 00F4 
; 0000 00F5 
; 0000 00F6 s++;
_0x21:
	INC  R5
; 0000 00F7 sm=60-s;
	MOV  R30,R5
	LDI  R31,0
	LDI  R26,LOW(60)
	LDI  R27,HIGH(60)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOV  R6,R30
; 0000 00F8 ltoa(sm,sc);
	MOV  R30,R6
	LDI  R31,0
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R30,LOW(_sc)
	LDI  R31,HIGH(_sc)
	CALL SUBOPT_0x15
; 0000 00F9 ltoa(cpm,cpmc);
	CALL SUBOPT_0x16
	CALL __PUTPARD1
	LDI  R30,LOW(_cpmc)
	LDI  R31,HIGH(_cpmc)
	CALL SUBOPT_0x15
; 0000 00FA ltoa(cph,cphc);
	LDS  R30,_cph
	LDS  R31,_cph+1
	LDS  R22,_cph+2
	LDS  R23,_cph+3
	CALL __PUTPARD1
	LDI  R30,LOW(_cphc)
	LDI  R31,HIGH(_cphc)
	CALL SUBOPT_0x15
; 0000 00FB 
; 0000 00FC 
; 0000 00FD if(sm>9){
	LDI  R30,LOW(9)
	CP   R30,R6
	BRSH _0x23
; 0000 00FE lcd_gotoxy(7,0);
	CALL SUBOPT_0x17
; 0000 00FF lcd_puts(sc);
	LDI  R30,LOW(_sc)
	LDI  R31,HIGH(_sc)
	CALL SUBOPT_0x8
; 0000 0100 }
; 0000 0101 
; 0000 0102 if(sm<10){
_0x23:
	LDI  R30,LOW(10)
	CP   R6,R30
	BRSH _0x24
; 0000 0103 lcd_gotoxy(7,0);
	CALL SUBOPT_0x17
; 0000 0104 lcd_puts("0");
	__POINTW1MN _0x22,59
	CALL SUBOPT_0x8
; 0000 0105 lcd_gotoxy(8,0);
	LDI  R30,LOW(8)
	CALL SUBOPT_0x18
; 0000 0106 lcd_puts(sc);
	LDI  R30,LOW(_sc)
	LDI  R31,HIGH(_sc)
	CALL SUBOPT_0x8
; 0000 0107 }
; 0000 0108 
; 0000 0109 
; 0000 010A 
; 0000 010B if(s==60){
_0x24:
	LDI  R30,LOW(60)
	CP   R30,R5
	BREQ PC+3
	JMP _0x25
; 0000 010C 
; 0000 010D 
; 0000 010E 
; 0000 010F s=0;
	CLR  R5
; 0000 0110 m++;
	INC  R4
; 0000 0111 
; 0000 0112 
; 0000 0113     if(cpm<9){
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1A
	BRSH _0x26
; 0000 0114     lcd_gotoxy(11,1);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x14
; 0000 0115     lcd_puts("0000");
	__POINTW1MN _0x22,61
	CALL SUBOPT_0x8
; 0000 0116     lcd_gotoxy(15,1);
	LDI  R30,LOW(15)
	CALL SUBOPT_0x14
; 0000 0117     lcd_puts(cpmc);
	CALL SUBOPT_0x1B
; 0000 0118     }
; 0000 0119 
; 0000 011A     if(cpm<99 && cpm>10){
_0x26:
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1C
	BRSH _0x28
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1D
	BRSH _0x29
_0x28:
	RJMP _0x27
_0x29:
; 0000 011B     lcd_gotoxy(11,1);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x14
; 0000 011C     lcd_puts("000");
	__POINTW1MN _0x22,66
	CALL SUBOPT_0x8
; 0000 011D     lcd_gotoxy(14,1);
	LDI  R30,LOW(14)
	CALL SUBOPT_0x14
; 0000 011E     lcd_puts(cpmc);
	CALL SUBOPT_0x1B
; 0000 011F     }
; 0000 0120 
; 0000 0121     if(cpm<999 && cpm>100){
_0x27:
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1E
	BRSH _0x2B
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1F
	BRSH _0x2C
_0x2B:
	RJMP _0x2A
_0x2C:
; 0000 0122     lcd_gotoxy(11,1);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x14
; 0000 0123     lcd_puts("00");
	__POINTW1MN _0x22,70
	CALL SUBOPT_0x8
; 0000 0124      lcd_gotoxy(13,1);
	LDI  R30,LOW(13)
	CALL SUBOPT_0x14
; 0000 0125     lcd_puts(cpmc);
	CALL SUBOPT_0x1B
; 0000 0126     }
; 0000 0127 
; 0000 0128     if(cpm<9999 && cpm>1000){
_0x2A:
	CALL SUBOPT_0x19
	CALL SUBOPT_0x20
	BRSH _0x2E
	CALL SUBOPT_0x19
	CALL SUBOPT_0x21
	BRSH _0x2F
_0x2E:
	RJMP _0x2D
_0x2F:
; 0000 0129     lcd_gotoxy(11,1);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x14
; 0000 012A     lcd_puts("0");
	__POINTW1MN _0x22,73
	CALL SUBOPT_0x8
; 0000 012B      lcd_gotoxy(12,1);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x14
; 0000 012C     lcd_puts(cpmc);
	CALL SUBOPT_0x1B
; 0000 012D     }
; 0000 012E 
; 0000 012F     if(cpm>9999){
_0x2D:
	CALL SUBOPT_0x19
	CALL SUBOPT_0x22
	BRLO _0x30
; 0000 0130     lcd_gotoxy(11,1);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x14
; 0000 0131     lcd_puts(cpmc);
	CALL SUBOPT_0x1B
; 0000 0132     }
; 0000 0133 
; 0000 0134     if(cpm>99999){
_0x30:
	CALL SUBOPT_0x19
	CALL SUBOPT_0x23
	BRLO _0x31
; 0000 0135     lcd_gotoxy(11,1);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x14
; 0000 0136     lcd_puts("-over-");
	__POINTW1MN _0x22,75
	CALL SUBOPT_0x8
; 0000 0137     }
; 0000 0138 
; 0000 0139     urh=cpm*38;
_0x31:
	CALL SUBOPT_0x16
	__GETD2N 0x26
	CALL __MULD12U
	CALL SUBOPT_0x24
; 0000 013A     urh=urh/100;
	CALL SUBOPT_0x25
	__GETD1N 0x64
	CALL __DIVD21U
	CALL SUBOPT_0x24
; 0000 013B     ltoa(urh,urhc);
	LDS  R30,_urh
	LDS  R31,_urh+1
	LDS  R22,_urh+2
	LDS  R23,_urh+3
	CALL __PUTPARD1
	LDI  R30,LOW(_urhc)
	LDI  R31,HIGH(_urhc)
	CALL SUBOPT_0x15
; 0000 013C 
; 0000 013D 
; 0000 013E     if(urh<30){
	CALL SUBOPT_0x25
	__CPD2N 0x1E
	BRSH _0x32
; 0000 013F     lcd_gotoxy(0,3);
	CALL SUBOPT_0x11
; 0000 0140     lcd_puts("NORM.");
	__POINTW1MN _0x22,82
	CALL SUBOPT_0x8
; 0000 0141     }
; 0000 0142 
; 0000 0143      if(urh>30 && urh<1000){
_0x32:
	CALL SUBOPT_0x25
	__CPD2N 0x1F
	BRLO _0x34
	CALL SUBOPT_0x25
	__CPD2N 0x3E8
	BRLO _0x35
_0x34:
	RJMP _0x33
_0x35:
; 0000 0144     lcd_gotoxy(0,3);
	CALL SUBOPT_0x11
; 0000 0145     lcd_puts("GOOD ");
	__POINTW1MN _0x22,88
	CALL SUBOPT_0x8
; 0000 0146     }
; 0000 0147 
; 0000 0148     if(urh>1000){
_0x33:
	CALL SUBOPT_0x25
	CALL SUBOPT_0x21
	BRSH PC+3
	JMP _0x36
; 0000 0149     n=urh/1000;
	CALL SUBOPT_0x25
	__GETD1N 0x3E8
	CALL __DIVD21U
	MOV  R7,R30
; 0000 014A     itoa(n,nc);
	MOV  R30,R7
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_nc)
	LDI  R31,HIGH(_nc)
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
; 0000 014B 
; 0000 014C 
; 0000 014D     if(n>99){
	LDI  R30,LOW(99)
	CP   R30,R7
	BRSH _0x37
; 0000 014E     lcd_gotoxy(0,3);
	CALL SUBOPT_0x11
; 0000 014F     lcd_puts(nc);
	CALL SUBOPT_0x26
; 0000 0150     }
; 0000 0151 
; 0000 0152     if(n>9 && n<100){
_0x37:
	LDI  R30,LOW(9)
	CP   R30,R7
	BRSH _0x39
	LDI  R30,LOW(100)
	CP   R7,R30
	BRLO _0x3A
_0x39:
	RJMP _0x38
_0x3A:
; 0000 0153     lcd_gotoxy(0,3);
	CALL SUBOPT_0x11
; 0000 0154     lcd_puts("0");
	__POINTW1MN _0x22,94
	CALL SUBOPT_0x8
; 0000 0155     lcd_gotoxy(1,3);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x27
; 0000 0156     lcd_puts(nc);
; 0000 0157     }
; 0000 0158 
; 0000 0159     if(n<9){
_0x38:
	LDI  R30,LOW(9)
	CP   R7,R30
	BRSH _0x3B
; 0000 015A     lcd_gotoxy(0,3);
	CALL SUBOPT_0x11
; 0000 015B     lcd_puts("00");
	__POINTW1MN _0x22,96
	CALL SUBOPT_0x8
; 0000 015C     lcd_gotoxy(2,3);
	LDI  R30,LOW(2)
	CALL SUBOPT_0x27
; 0000 015D     lcd_puts(nc);
; 0000 015E     }
; 0000 015F 
; 0000 0160     lcd_gotoxy(4,3);
_0x3B:
	LDI  R30,LOW(4)
	CALL SUBOPT_0x28
; 0000 0161     lcd_puts("x");
	__POINTW1MN _0x22,99
	CALL SUBOPT_0x8
; 0000 0162     }
; 0000 0163 
; 0000 0164  if(urh<9){
_0x36:
	CALL SUBOPT_0x25
	CALL SUBOPT_0x1A
	BRSH _0x3C
; 0000 0165     lcd_gotoxy(0,2);
	CALL SUBOPT_0x10
; 0000 0166     lcd_puts("0000");
	__POINTW1MN _0x22,101
	CALL SUBOPT_0x8
; 0000 0167     lcd_gotoxy(4,2);
	LDI  R30,LOW(4)
	CALL SUBOPT_0x29
; 0000 0168     lcd_puts(urhc);
; 0000 0169     }
; 0000 016A 
; 0000 016B     if(urh<99 && urh>10){
_0x3C:
	CALL SUBOPT_0x25
	CALL SUBOPT_0x1C
	BRSH _0x3E
	CALL SUBOPT_0x25
	CALL SUBOPT_0x1D
	BRSH _0x3F
_0x3E:
	RJMP _0x3D
_0x3F:
; 0000 016C     lcd_gotoxy(0,2);
	CALL SUBOPT_0x10
; 0000 016D     lcd_puts("000");
	__POINTW1MN _0x22,106
	CALL SUBOPT_0x8
; 0000 016E     lcd_gotoxy(3,2);
	LDI  R30,LOW(3)
	CALL SUBOPT_0x29
; 0000 016F     lcd_puts(urhc);
; 0000 0170     }
; 0000 0171 
; 0000 0172     if(urh<999 && urh>100){
_0x3D:
	CALL SUBOPT_0x25
	CALL SUBOPT_0x1E
	BRSH _0x41
	CALL SUBOPT_0x25
	CALL SUBOPT_0x1F
	BRSH _0x42
_0x41:
	RJMP _0x40
_0x42:
; 0000 0173     lcd_gotoxy(0,2);
	CALL SUBOPT_0x10
; 0000 0174     lcd_puts("00");
	__POINTW1MN _0x22,110
	CALL SUBOPT_0x8
; 0000 0175      lcd_gotoxy(2,2);
	LDI  R30,LOW(2)
	CALL SUBOPT_0x29
; 0000 0176     lcd_puts(urhc);
; 0000 0177     }
; 0000 0178 
; 0000 0179     if(urh<9999 && urh>1000){
_0x40:
	CALL SUBOPT_0x25
	CALL SUBOPT_0x20
	BRSH _0x44
	CALL SUBOPT_0x25
	CALL SUBOPT_0x21
	BRSH _0x45
_0x44:
	RJMP _0x43
_0x45:
; 0000 017A     lcd_gotoxy(0,2);
	CALL SUBOPT_0x10
; 0000 017B     lcd_puts("0");
	__POINTW1MN _0x22,113
	CALL SUBOPT_0x8
; 0000 017C      lcd_gotoxy(1,2);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x29
; 0000 017D     lcd_puts(urhc);
; 0000 017E     }
; 0000 017F 
; 0000 0180     if(urh>9999){
_0x43:
	CALL SUBOPT_0x25
	CALL SUBOPT_0x22
	BRLO _0x46
; 0000 0181     lcd_gotoxy(0,2);
	CALL SUBOPT_0x10
; 0000 0182     lcd_puts(urhc);
	LDI  R30,LOW(_urhc)
	LDI  R31,HIGH(_urhc)
	CALL SUBOPT_0x8
; 0000 0183     }
; 0000 0184 
; 0000 0185     if(urh>99999){
_0x46:
	CALL SUBOPT_0x25
	CALL SUBOPT_0x23
	BRLO _0x47
; 0000 0186     lcd_gotoxy(0,2);
	CALL SUBOPT_0x10
; 0000 0187     lcd_puts("-over-");
	__POINTW1MN _0x22,115
	CALL SUBOPT_0x8
; 0000 0188     }
; 0000 0189 
; 0000 018A     cpm=0;
_0x47:
	CALL SUBOPT_0x2
; 0000 018B     urh=0;
	LDI  R30,LOW(0)
	STS  _urh,R30
	STS  _urh+1,R30
	STS  _urh+2,R30
	STS  _urh+3,R30
; 0000 018C 
; 0000 018D 
; 0000 018E 
; 0000 018F if(m==60){
	LDI  R30,LOW(60)
	CP   R30,R4
	BREQ PC+3
	JMP _0x48
; 0000 0190 m=0;
	CLR  R4
; 0000 0191 
; 0000 0192     if(cph<9){
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x1A
	BRSH _0x49
; 0000 0193     lcd_gotoxy(11,2);
	CALL SUBOPT_0x2B
; 0000 0194     lcd_puts("0000");
	__POINTW1MN _0x22,122
	CALL SUBOPT_0x8
; 0000 0195     lcd_gotoxy(15,2);
	LDI  R30,LOW(15)
	CALL SUBOPT_0x2C
; 0000 0196     lcd_puts(cphc);
; 0000 0197     }
; 0000 0198 
; 0000 0199     if(cph<99 && cph>10){
_0x49:
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x1C
	BRSH _0x4B
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x1D
	BRSH _0x4C
_0x4B:
	RJMP _0x4A
_0x4C:
; 0000 019A     lcd_gotoxy(11,2);
	CALL SUBOPT_0x2B
; 0000 019B     lcd_puts("000");
	__POINTW1MN _0x22,127
	CALL SUBOPT_0x8
; 0000 019C     lcd_gotoxy(14,2);
	LDI  R30,LOW(14)
	CALL SUBOPT_0x2C
; 0000 019D     lcd_puts(cphc);
; 0000 019E     }
; 0000 019F 
; 0000 01A0     if(cph<999 && cph>100){
_0x4A:
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x1E
	BRSH _0x4E
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x1F
	BRSH _0x4F
_0x4E:
	RJMP _0x4D
_0x4F:
; 0000 01A1     lcd_gotoxy(11,2);
	CALL SUBOPT_0x2B
; 0000 01A2     lcd_puts("00");
	__POINTW1MN _0x22,131
	CALL SUBOPT_0x8
; 0000 01A3      lcd_gotoxy(13,2);
	LDI  R30,LOW(13)
	CALL SUBOPT_0x2C
; 0000 01A4     lcd_puts(cphc);
; 0000 01A5     }
; 0000 01A6 
; 0000 01A7     if(cph<9999 && cph>1000){
_0x4D:
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x20
	BRSH _0x51
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x21
	BRSH _0x52
_0x51:
	RJMP _0x50
_0x52:
; 0000 01A8     lcd_gotoxy(11,2);
	CALL SUBOPT_0x2B
; 0000 01A9     lcd_puts("0");
	__POINTW1MN _0x22,134
	CALL SUBOPT_0x8
; 0000 01AA      lcd_gotoxy(12,2);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x2C
; 0000 01AB     lcd_puts(cphc);
; 0000 01AC     }
; 0000 01AD 
; 0000 01AE     if(cph>9999){
_0x50:
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x22
	BRLO _0x53
; 0000 01AF     lcd_gotoxy(11,2);
	CALL SUBOPT_0x2B
; 0000 01B0     lcd_puts(cphc);
	LDI  R30,LOW(_cphc)
	LDI  R31,HIGH(_cphc)
	CALL SUBOPT_0x8
; 0000 01B1     }
; 0000 01B2 
; 0000 01B3     if(cph>99999){
_0x53:
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x23
	BRLO _0x54
; 0000 01B4     lcd_gotoxy(11,2);
	CALL SUBOPT_0x2B
; 0000 01B5     lcd_puts("-over-");
	__POINTW1MN _0x22,136
	CALL SUBOPT_0x8
; 0000 01B6     }
; 0000 01B7 
; 0000 01B8     cph=0;
_0x54:
	CALL SUBOPT_0x3
; 0000 01B9 
; 0000 01BA }
; 0000 01BB 
; 0000 01BC 
; 0000 01BD }
_0x48:
; 0000 01BE 
; 0000 01BF lcd_gotoxy(6,2);
_0x25:
	LDI  R30,LOW(6)
	CALL SUBOPT_0x2D
; 0000 01C0 lcd_puts("uR/h");
	__POINTW1MN _0x22,143
	CALL SUBOPT_0x8
; 0000 01C1 
; 0000 01C2 lcd_gotoxy(10,1);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x14
; 0000 01C3 lcd_puts("|");
	__POINTW1MN _0x22,148
	CALL SUBOPT_0x8
; 0000 01C4 
; 0000 01C5 lcd_gotoxy(17,1);
	LDI  R30,LOW(17)
	CALL SUBOPT_0x14
; 0000 01C6 lcd_puts("cpm");
	__POINTW1MN _0x22,150
	CALL SUBOPT_0x8
; 0000 01C7 
; 0000 01C8 lcd_gotoxy(0,0);
	CALL SUBOPT_0xF
; 0000 01C9 lcd_puts("UPDATE:");
	__POINTW1MN _0x22,154
	CALL SUBOPT_0x8
; 0000 01CA 
; 0000 01CB lcd_gotoxy(9,0);
	LDI  R30,LOW(9)
	CALL SUBOPT_0x18
; 0000 01CC lcd_puts("s");
	__POINTW1MN _0x22,162
	CALL SUBOPT_0x8
; 0000 01CD 
; 0000 01CE lcd_gotoxy(10,0);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x18
; 0000 01CF lcd_puts("|");
	__POINTW1MN _0x22,164
	CALL SUBOPT_0x8
; 0000 01D0 
; 0000 01D1 
; 0000 01D2 lcd_gotoxy(17,2);
	LDI  R30,LOW(17)
	CALL SUBOPT_0x2D
; 0000 01D3 lcd_puts("cph");
	__POINTW1MN _0x22,166
	CALL SUBOPT_0x8
; 0000 01D4 
; 0000 01D5 lcd_gotoxy(10,2);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x2D
; 0000 01D6 lcd_puts("|");
	__POINTW1MN _0x22,170
	CALL SUBOPT_0x8
; 0000 01D7 
; 0000 01D8 
; 0000 01D9 
; 0000 01DA lcd_gotoxy(5,3);
	LDI  R30,LOW(5)
	CALL SUBOPT_0x28
; 0000 01DB lcd_puts("|");
	__POINTW1MN _0x22,172
	CALL SUBOPT_0x8
; 0000 01DC 
; 0000 01DD 
; 0000 01DE lcd_gotoxy(17,3);
	LDI  R30,LOW(17)
	CALL SUBOPT_0x28
; 0000 01DF lcd_puts("ctt");
	__POINTW1MN _0x22,174
	CALL SUBOPT_0x8
; 0000 01E0  }
_0x5C:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI

	.DSEG
_0x22:
	.BYTE 0xB2
;
;
;
;
;
;
;
;#define ADC_VREF_TYPE 0xC0
;
;// Read the AD conversion result
;unsigned int read_adc(unsigned char adc_input)
; 0000 01EC {

	.CSEG
; 0000 01ED ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
; 0000 01EE // Delay needed for the stabilization of the ADC input voltage
; 0000 01EF delay_us(10);
; 0000 01F0 // Start the AD conversion
; 0000 01F1 ADCSRA|=0x40;
; 0000 01F2 // Wait for the AD conversion to complete
; 0000 01F3 while ((ADCSRA & 0x10)==0);
; 0000 01F4 ADCSRA|=0x10;
; 0000 01F5 return ADCW;
; 0000 01F6 }
;
;// Declare your global variables here
;
;void main(void)
; 0000 01FB {
_main:
; 0000 01FC // Declare your local variables here
; 0000 01FD 
; 0000 01FE // Input/Output Ports initialization
; 0000 01FF // Port A initialization
; 0000 0200 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0201 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0202 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 0203 DDRA=0x00;
	OUT  0x1A,R30
; 0000 0204 
; 0000 0205 // Port B initialization
; 0000 0206 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0207 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0208 PORTB=0x00;
	OUT  0x18,R30
; 0000 0209 DDRB=0x00;
	OUT  0x17,R30
; 0000 020A 
; 0000 020B // Port C initialization
; 0000 020C // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 020D // State7=T State6=T State5=P State4=P State3=P State2=P State1=P State0=P
; 0000 020E PORTC=0x3F;
	LDI  R30,LOW(63)
	OUT  0x15,R30
; 0000 020F DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0000 0210 
; 0000 0211 // Port D initialization
; 0000 0212 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0213 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0214 PORTD=0x00;
	OUT  0x12,R30
; 0000 0215 DDRD=0x00;
	OUT  0x11,R30
; 0000 0216 
; 0000 0217 // Timer/Counter 0 initialization
; 0000 0218 // Clock source: System Clock
; 0000 0219 // Clock value: Timer 0 Stopped
; 0000 021A // Mode: Normal top=0xFF
; 0000 021B // OC0 output: Disconnected
; 0000 021C TCCR0=0x00;
	OUT  0x33,R30
; 0000 021D TCNT0=0x00;
	OUT  0x32,R30
; 0000 021E OCR0=0x00;
	OUT  0x3C,R30
; 0000 021F 
; 0000 0220 // Timer/Counter 1 initialization
; 0000 0221 // Clock source: System Clock
; 0000 0222 // Clock value: Timer1 Stopped
; 0000 0223 // Mode: Normal top=0xFFFF
; 0000 0224 // OC1A output: Discon.
; 0000 0225 // OC1B output: Discon.
; 0000 0226 // Noise Canceler: Off
; 0000 0227 // Input Capture on Falling Edge
; 0000 0228 // Timer1 Overflow Interrupt: Off
; 0000 0229 // Input Capture Interrupt: Off
; 0000 022A // Compare A Match Interrupt: Off
; 0000 022B // Compare B Match Interrupt: Off
; 0000 022C TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 022D TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 022E TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 022F TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0230 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0231 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0232 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0233 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0234 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0235 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0236 
; 0000 0237 // Timer/Counter 2 initialization
; 0000 0238 // Clock source: TOSC1 pin
; 0000 0239 // Clock value: PCK2/128
; 0000 023A // Mode: Normal top=0xFF
; 0000 023B // OC2 output: Disconnected
; 0000 023C ASSR=0x08;
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 023D TCCR2=0x05;
	LDI  R30,LOW(5)
	OUT  0x25,R30
; 0000 023E TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 023F OCR2=0x00;
	OUT  0x23,R30
; 0000 0240 
; 0000 0241 // External Interrupt(s) initialization
; 0000 0242 // INT0: Off
; 0000 0243 // INT1: Off
; 0000 0244 // INT2: On
; 0000 0245 // INT2 Mode: Falling Edge
; 0000 0246 GICR|=0x20;
	IN   R30,0x3B
	ORI  R30,0x20
	OUT  0x3B,R30
; 0000 0247 MCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x35,R30
; 0000 0248 MCUCSR=0x00;
	OUT  0x34,R30
; 0000 0249 GIFR=0x20;
	LDI  R30,LOW(32)
	OUT  0x3A,R30
; 0000 024A 
; 0000 024B 
; 0000 024C // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 024D TIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x39,R30
; 0000 024E 
; 0000 024F // USART initialization
; 0000 0250 // USART disabled
; 0000 0251 UCSRB=0x00;
	LDI  R30,LOW(0)
	OUT  0xA,R30
; 0000 0252 
; 0000 0253 // Analog Comparator initialization
; 0000 0254 // Analog Comparator: On
; 0000 0255 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0256 ACSR=0x00;
	OUT  0x8,R30
; 0000 0257 SFIOR=0x00;
	OUT  0x30,R30
; 0000 0258 
; 0000 0259 // ADC initialization
; 0000 025A // ADC Clock frequency: 1000,000 kHz
; 0000 025B // ADC Voltage Reference: Int., cap. on AREF
; 0000 025C // ADC Auto Trigger Source: Free Running
; 0000 025D ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(192)
	OUT  0x7,R30
; 0000 025E ADCSRA=0xA4;
	LDI  R30,LOW(164)
	OUT  0x6,R30
; 0000 025F SFIOR&=0x1F;
	IN   R30,0x30
	ANDI R30,LOW(0x1F)
	OUT  0x30,R30
; 0000 0260 
; 0000 0261 // SPI initialization
; 0000 0262 // SPI disabled
; 0000 0263 SPCR=0x00;
	LDI  R30,LOW(0)
	OUT  0xD,R30
; 0000 0264 
; 0000 0265 // TWI initialization
; 0000 0266 // TWI disabled
; 0000 0267 TWCR=0x00;
	OUT  0x36,R30
; 0000 0268 
; 0000 0269 // Alphanumeric LCD initialization
; 0000 026A // Connections specified in the
; 0000 026B // Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
; 0000 026C // RS - PORTD Bit 0
; 0000 026D // RD - PORTD Bit 1
; 0000 026E // EN - PORTD Bit 2
; 0000 026F // D4 - PORTD Bit 4
; 0000 0270 // D5 - PORTD Bit 5
; 0000 0271 // D6 - PORTD Bit 6
; 0000 0272 // D7 - PORTD Bit 7
; 0000 0273 // Characters/line: 8
; 0000 0274 lcd_init(20);
	LDI  R30,LOW(20)
	ST   -Y,R30
	RCALL _lcd_init
; 0000 0275 
; 0000 0276 
; 0000 0277 
; 0000 0278 // Global enable interrupts
; 0000 0279 #asm("sei")
	sei
; 0000 027A 
; 0000 027B while (1)
_0x58:
; 0000 027C       {
; 0000 027D 
; 0000 027E 
; 0000 027F 
; 0000 0280       }
	RJMP _0x58
; 0000 0281 }
_0x5B:
	RJMP _0x5B
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G100:
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2000004
	SBI  0x12,4
	RJMP _0x2000005
_0x2000004:
	CBI  0x12,4
_0x2000005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2000006
	SBI  0x12,5
	RJMP _0x2000007
_0x2000006:
	CBI  0x12,5
_0x2000007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2000008
	SBI  0x12,6
	RJMP _0x2000009
_0x2000008:
	CBI  0x12,6
_0x2000009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x200000A
	SBI  0x12,7
	RJMP _0x200000B
_0x200000A:
	CBI  0x12,7
_0x200000B:
	__DELAY_USB 11
	SBI  0x12,2
	__DELAY_USB 27
	CBI  0x12,2
	__DELAY_USB 27
	RJMP _0x20A0001
__lcd_write_data:
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
	__DELAY_USW 200
	RJMP _0x20A0001
_lcd_gotoxy:
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	RCALL __lcd_write_data
	LDD  R8,Y+1
	LDD  R11,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R30,LOW(2)
	CALL SUBOPT_0x2E
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(1)
	CALL SUBOPT_0x2E
	LDI  R30,LOW(0)
	MOV  R11,R30
	MOV  R8,R30
	RET
_lcd_putchar:
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2000011
	CP   R8,R10
	BRLO _0x2000010
_0x2000011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	INC  R11
	ST   -Y,R11
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2000013
	RJMP _0x20A0001
_0x2000013:
_0x2000010:
	INC  R8
	SBI  0x12,0
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_data
	CBI  0x12,0
	RJMP _0x20A0001
_lcd_puts:
	ST   -Y,R17
_0x2000014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000016
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2000014
_0x2000016:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_lcd_init:
	SBI  0x11,4
	SBI  0x11,5
	SBI  0x11,6
	SBI  0x11,7
	SBI  0x11,2
	SBI  0x11,0
	SBI  0x11,1
	CBI  0x12,2
	CBI  0x12,0
	CBI  0x12,1
	LDD  R10,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2F
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
	__DELAY_USW 400
	LDI  R30,LOW(40)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(133)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x20A0001:
	ADIW R28,1
	RET

	.CSEG
_itoa:
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret
_ltoa:
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	__GETD1N 0x3B9ACA00
	__PUTD1S 2
	LDI  R16,LOW(0)
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020003
	__GETD1S 8
	CALL __ANEGD1
	__PUTD1S 8
	CALL SUBOPT_0x30
	LDI  R30,LOW(45)
	ST   X,R30
_0x2020003:
_0x2020005:
	CALL SUBOPT_0x31
	CALL __DIVD21U
	MOV  R17,R30
	CPI  R17,0
	BRNE _0x2020008
	CPI  R16,0
	BRNE _0x2020008
	__GETD2S 2
	__CPD2N 0x1
	BRNE _0x2020007
_0x2020008:
	CALL SUBOPT_0x30
	MOV  R30,R17
	SUBI R30,-LOW(48)
	ST   X,R30
	LDI  R16,LOW(1)
_0x2020007:
	CALL SUBOPT_0x31
	CALL __MODD21U
	__PUTD1S 8
	__GETD2S 2
	__GETD1N 0xA
	CALL __DIVD21U
	__PUTD1S 2
	CALL __CPD10
	BRNE _0x2020005
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,12
	RET

	.DSEG

	.CSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_cpm:
	.BYTE 0x4
_cph:
	.BYTE 0x4
_ctt:
	.BYTE 0x4
_urh:
	.BYTE 0x4
_cpmc:
	.BYTE 0xF
_cphc:
	.BYTE 0xF
_cttc:
	.BYTE 0x1B
_sc:
	.BYTE 0x6
_urhc:
	.BYTE 0xF
_nc:
	.BYTE 0x9
__base_y_G100:
	.BYTE 0x4
__seed_G101:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x0:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	LDI  R30,LOW(1)
	CP   R30,R9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1:
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	STS  _cpm,R30
	STS  _cpm+1,R30
	STS  _cpm+2,R30
	STS  _cpm+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(0)
	STS  _cph,R30
	STS  _cph+1,R30
	STS  _cph+2,R30
	STS  _cph+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	LDS  R30,_ctt
	LDS  R31,_ctt+1
	LDS  R22,_ctt+2
	LDS  R23,_ctt+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(_cttc)
	LDI  R31,HIGH(_cttc)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x6:
	LDS  R26,_ctt
	LDS  R27,_ctt+1
	LDS  R24,_ctt+2
	LDS  R25,_ctt+3
	__CPD2N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 64 TIMES, CODE SIZE REDUCTION:123 WORDS
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x9:
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _lcd_gotoxy
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xA:
	LDS  R26,_ctt
	LDS  R27,_ctt+1
	LDS  R24,_ctt+2
	LDS  R25,_ctt+3
	__CPD2N 0x64
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xB:
	LDS  R26,_ctt
	LDS  R27,_ctt+1
	LDS  R24,_ctt+2
	LDS  R25,_ctt+3
	__CPD2N 0x3E8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xC:
	LDS  R26,_ctt
	LDS  R27,_ctt+1
	LDS  R24,_ctt+2
	LDS  R25,_ctt+3
	__CPD2N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xD:
	LDS  R26,_ctt
	LDS  R27,_ctt+1
	LDS  R24,_ctt+2
	LDS  R25,_ctt+3
	__CPD2N 0x186A0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xE:
	LDS  R26,_ctt
	LDS  R27,_ctt+1
	LDS  R24,_ctt+2
	LDS  R25,_ctt+3
	__CPD2N 0xF4240
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:73 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:159 WORDS
SUBOPT_0x13:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_putchar
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x14:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x15:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _ltoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x16:
	LDS  R30,_cpm
	LDS  R31,_cpm+1
	LDS  R22,_cpm+2
	LDS  R23,_cpm+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x18:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x19:
	LDS  R26,_cpm
	LDS  R27,_cpm+1
	LDS  R24,_cpm+2
	LDS  R25,_cpm+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1A:
	__CPD2N 0x9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(_cpmc)
	LDI  R31,HIGH(_cpmc)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1C:
	__CPD2N 0x63
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1D:
	__CPD2N 0xB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1E:
	__CPD2N 0x3E7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1F:
	__CPD2N 0x65
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x20:
	__CPD2N 0x270F
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x21:
	__CPD2N 0x3E9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x22:
	__CPD2N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x23:
	__CPD2N 0x186A0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x24:
	STS  _urh,R30
	STS  _urh+1,R31
	STS  _urh+2,R22
	STS  _urh+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:81 WORDS
SUBOPT_0x25:
	LDS  R26,_urh
	LDS  R27,_urh+1
	LDS  R24,_urh+2
	LDS  R25,_urh+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	LDI  R30,LOW(_nc)
	LDI  R31,HIGH(_nc)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x27:
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _lcd_gotoxy
	RJMP SUBOPT_0x26

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x28:
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x29:
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(_urhc)
	LDI  R31,HIGH(_urhc)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x2A:
	LDS  R26,_cph
	LDS  R27,_cph+1
	LDS  R24,_cph+2
	LDS  R25,_cph+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x2B:
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x2C:
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(_cphc)
	LDI  R31,HIGH(_cphc)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2D:
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2E:
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2F:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL __lcd_write_nibble_G100
	__DELAY_USW 400
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x30:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x31:
	__GETD1S 2
	__GETD2S 8
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

;END OF CODE MARKER
__END_OF_CODE:
